{-# LANGUAGE FlexibleInstances, RecordWildCards #-}
import Criterion
import Criterion.Main
import Criterion.Monad
import Criterion.IO
import Criterion.Measurement
import Criterion.Analysis
import Criterion.Types
import Data.Monoid
import Criterion.Environment
import System.Environment
import Statistics.Resampling.Bootstrap (Estimate(..))
import Control.Monad.Trans
import Criterion.Config
import Control.DeepSeq
import Data.Generics
import Data.List
import qualified Data.Vector.Unboxed as V (filter, toList, length)
import Control.Monad
import Language.Haskell.Syntax
import Language.Haskell.Parser
import Language.Haskell.Lexer
import Language.Haskell.ParseMonad
import Statistics.Types
import Statistics.Types (Sample)
import Criterion.Report
import Text.Printf

--benches :: (NFData b) => a -> [(String, a -> b)] -> [Benchmark]
--benches arg ((name, b) : bs) = bs' `seq` (bench name (nf b arg)) : bs' where bs'
-- = benches arg bs
--benches _ [] = []

file_names = map ("../base-4.5.1.0/"++) -- ["../Map.hspp"]
  [ "./Control/Applicative.hspp"
  , "./Control/Arrow.hspp"
  , "./Control/Category.hspp"
  --, "./Control/Concurrent.hspp"
  --, "./Control/Concurrent/Chan.hspp"
  , "./Control/Concurrent/MVar.hspp"
  --, "./Control/Concurrent/QSem.hspp"
  --, "./Control/Concurrent/QSemN.hspp"
  --, "./Control/Concurrent/SampleVar.hspp"
  --, "./Control/Exception.hspp"
  --, "./Control/Exception/Base.hspp"
  , "./Control/Monad.hspp"
  , "./Control/Monad/Fix.hspp"
  , "./Control/Monad/Instances.hspp"
  , "./Control/Monad/ST.hspp"
  , "./Control/Monad/ST/Imp.hspp"
  , "./Control/Monad/ST/Lazy.hspp"
  --, "./Control/Monad/ST/Lazy/Imp.hspp"
  , "./Control/Monad/ST/Lazy/Safe.hspp"
  , "./Control/Monad/ST/Lazy/Unsafe.hspp"
  , "./Control/Monad/ST/Safe.hspp"
  , "./Control/Monad/ST/Strict.hspp"
  , "./Control/Monad/ST/Unsafe.hspp"
  , "./Control/Monad/Zip.hspp"
  --, "./Control/OldException.hspp"
  --, "./Data/Bits.hspp"
  , "./Data/Bool.hspp"
  , "./Data/Char.hspp"
  --, "./Data/Complex.hspp"
  --, "./Data/Data.hspp"
  --, "./Data/Dynamic.hspp"
  --, "./Data/Either.hspp"
  , "./Data/Eq.hspp"
  , "./Data/Fixed.hspp"
  , "./Data/Foldable.hspp"
  , "./Data/Function.hspp"
  , "./Data/Functor.hspp"
  , "./Data/HashTable.hspp"
  --, "./Data/IORef.hspp"
  , "./Data/Int.hspp"
  , "./Data/Ix.hspp"
  , "./Data/List.hspp"
  , "./Data/Maybe.hspp"
  , "./Data/Monoid.hspp"
  , "./Data/Ord.hspp"
  , "./Data/Ratio.hspp"
  , "./Data/STRef.hspp"
  , "./Data/STRef/Lazy.hspp"
  , "./Data/STRef/Strict.hspp"
  , "./Data/String.hspp"
  , "./Data/Traversable.hspp"
  , "./Data/Tuple.hspp"
  , "./Data/Typeable.hspp"
  --, "./Data/Typeable/Internal.hspp"
  , "./Data/Unique.hspp"
  , "./Data/Version.hspp"
  , "./Data/Word.hspp"
  --, "./Debug/Trace.hspp" -- Uses magic hash
  , "./Foreign.hspp"
  , "./Foreign/C.hspp"
  , "./Foreign/C/Error.hspp"
  , "./Foreign/C/String.hspp"
  --, "./Foreign/C/Types.hspp"
  , "./Foreign/Concurrent.hspp"
  , "./Foreign/ForeignPtr.hspp"
  , "./Foreign/ForeignPtr/Imp.hspp"
  , "./Foreign/ForeignPtr/Safe.hspp"
  , "./Foreign/ForeignPtr/Unsafe.hspp"
  , "./Foreign/Marshal.hspp"
  --, "./Foreign/Marshal/Alloc.hspp"
  --, "./Foreign/Marshal/Array.hspp"
  , "./Foreign/Marshal/Error.hspp"
  , "./Foreign/Marshal/Pool.hspp"
  , "./Foreign/Marshal/Safe.hspp"
  , "./Foreign/Marshal/Unsafe.hspp"
  , "./Foreign/Marshal/Utils.hspp"
  --, "./Foreign/Ptr.hspp"
  , "./Foreign/Safe.hspp"
  , "./Foreign/StablePtr.hspp"
  --, "./Foreign/Storable.hspp"
  --, "./GHC/Arr.hspp"
  --, "./GHC/Base.hspp"
  , "./GHC/Conc.hspp"
  --, "./GHC/Conc/IO.hspp"
  , "./GHC/Conc/Signal.hspp"
  --, "./GHC/Conc/Sync.hspp"
  --, "./GHC/Conc/Windows.hspp"
  , "./GHC/ConsoleHandler.hspp"
  --, "./GHC/Desugar.hspp"
  --, "./GHC/Enum.hspp"
  , "./GHC/Environment.hspp"
  , "./GHC/Err.hspp"
  , "./GHC/Event.hspp"
  --, "./GHC/Event/Array.hspp"
  --, "./GHC/Event/Control.hspp"
  --, "./GHC/Event/IntMap.hspp"
  --, "./GHC/Event/Internal.hspp"
  --, "./GHC/Event/Manager.hspp"
  --, "./GHC/Event/PSQ.hspp"
  --, "./GHC/Event/Thread.hspp"
  --, "./GHC/Event/Unique.hspp"
  --, "./GHC/Exception.hspp"
  --, "./GHC/Exts.hspp"
  --, "./GHC/Fingerprint.hspp"
  , "./GHC/Fingerprint/Type.hspp"
  --, "./GHC/Float/ConversionUtils.hspp"
  --, "./GHC/Float/RealFracMethods.hspp"
  , "./GHC/Foreign.hspp"
  --, "./GHC/ForeignPtr.hspp"
  , "./GHC/Handle.hspp"
  --, "./GHC/IO.hspp"
  , "./GHC/IO/Buffer.hspp"
  , "./GHC/IO/BufferedIO.hspp"
  , "./GHC/IO/Device.hspp"
  , "./GHC/IO/Encoding.hspp"
  , "./GHC/IO/Encoding/CodePage.hspp"
  --, "./GHC/IO/Encoding/CodePage/Table.hspp"
  --, "./GHC/IO/Encoding/Failure.hspp"
  --, "./GHC/IO/Encoding/Iconv.hspp"
  --, "./GHC/IO/Encoding/Latin1.hspp"
  --, "./GHC/IO/Encoding/Types.hspp"
  --, "./GHC/IO/Encoding/UTF16.hspp"
  --, "./GHC/IO/Encoding/UTF32.hspp"
  --, "./GHC/IO/Encoding/UTF8.hspp"
  --, "./GHC/IO/Exception.hspp"
  --, "./GHC/IO/FD.hspp"
  --, "./GHC/IO/Handle.hspp"
  --, "./GHC/IO/Handle/FD.hspp"
  --, "./GHC/IO/Handle/Internals.hspp"
  --, "./GHC/IO/Handle/Text.hspp"
  --, "./GHC/IO/Handle/Types.hspp"
  , "./GHC/IO/IOMode.hspp"
  , "./GHC/IOArray.hspp"
  , "./GHC/IOBase.hspp"
  --, "./GHC/IORef.hspp"
  --, "./GHC/Int.hspp"
  --, "./GHC/List.hspp"
  --, "./GHC/MVar.hspp"
  --, "./GHC/Num.hspp"
  --, "./GHC/PArr.hspp"
  --, "./GHC/Pack.hspp"
  --, "./GHC/Ptr.hspp"
  --, "./GHC/Read.hspp"
  --, "./GHC/Real.hspp"
  --, "./GHC/ST.hspp"
  --, "./GHC/STRef.hspp"
  --, "./GHC/Show.hspp"
  --, "./GHC/Stable.hspp"
  --, "./GHC/Storable.hspp"
  --, "./GHC/TopHandler.hspp"
  , "./GHC/Unicode.hspp"
  --, "./GHC/Weak.hspp"
  , "./GHC/Windows.hspp"
  --, "./GHC/Word.hspp"
  --, "./Numeric.hspp"
  --, "./Prelude.hspp"
  , "./Setup.hspp"
  , "./System/Console/GetOpt.hspp"
  , "./System/Environment.hspp"
  , "./System/Exit.hspp"
  , "./System/IO.hspp"
  , "./System/IO/Error.hspp"
  , "./System/IO/Unsafe.hspp"
  , "./System/Info.hspp"
  --, "./System/Mem.hspp"
  --, "./System/Mem/StableName.hspp"
  , "./System/Mem/Weak.hspp"
  , "./System/Posix/Internals.hspp"
  --, "./System/Posix/Types.hspp"
  --, "./System/Timeout.hspp"
  --, "./Text/ParserCombinators/ReadP.hspp" -- Uses "forall" and rank 2 types
  , "./Text/ParserCombinators/ReadPrec.hspp"
  , "./Text/Printf.hspp"
  , "./Text/Read.hspp"
  , "./Text/Read/Lex.hspp"
  , "./Text/Show.hspp"
  , "./Text/Show/Functions.hspp"
  --, "./Unsafe/Coerce.hspp"
  ]

instance NFData (ParseResult a) where
  rnf x = x `seq` ()

class IsEOF x where
  isEOF :: x -> Bool

instance IsEOF Token where
  isEOF EOF = True
  isEOF _ = False

instance IsEOF (Token, a) where
  isEOF (EOF, _) = True
  isEOF _ = False

runLexer str = runParser (lexer f) str where
  f x = if isEOF x
        then return 0
        else do x <- lexer f
                return (x + 1)

getFile file = do
  pre_str <- readFile file
  let str = unlines (map (\line -> case line of '#':' ':_ -> ""; _ -> line) (lines pre_str))
  case parseModule str of
    ParseFailed srcLoc string -> do
      putStrLn $ "Parse Error at " ++ file ++ ":" ++ show srcLoc
      return (file, str, Nothing)
    ParseOk ast -> do
      case runLexer str of
        ParseFailed srcLoc string -> error $ "Lex error: " ++ string ++ "\nAt " ++ file ++ ":" ++ show srcLoc
        ParseOk numTokens -> do
          appendFile "meta-data.txt" $ file++","++(show (length str))++","++(show numTokens)++","++(show $ length $ lines str)++","++(show (everything (+) (const (1::Int)) ast))++"\n"
      return (file, str, Just ast)

benches :: String -> IO [Bench]
benches file_name = do
  file <- getFile file_names
  let () = rnf (show files)
  let (_, str, ast) = file
  defaultMainWith' cfg (return ())
    [ bench ("Show Parse/"++file_name) (nf (show . parseModule) str)
    , bench ("Parse/"++file_name) (nf parseModule str)
    , bench ("Base/Id Str/"++file_name) (nf id str)
    , bench ("Base/Lex Str/"++file_name) (nf runLexer str)
    , bench ("Base/Show AST/"++file_name) (nf show ast)
    ]

main :: IO ()
main = do
  writeFile "meta-data.txt" ""
  --files <- mapM getFile file_names
  --let () = rnf (show files)

  putStrLn "\n\n----------------------------------------\n"

  cfg <- fmap fst $ parseArgs defaultConfig defaultOptions []

  benches ["../hackage/hackage-2012-10-08/

{-
  defaultMainWith' cfg (return ()) [
    bgroup "Show Parse" [bench file (nf (show . parseModule) str) | (file, str, ast) <- files],
    bgroup "Parse" [bench file (nf parseModule str) | (file, str, ast) <- files],
    bgroup "Base/Id Str" [bench file (nf id str) | (file, str, ast) <- files],
    bgroup "Base/Lex Str" [bench file (nf runLexer str) | (file, str, ast) <- files],
    bgroup "Base/Show AST" [bench file (nf show ast) | (file, str, ast) <- files]
    ]
-}

---------------------------
-- The following code is taken from Criterion

defaultMainWith' :: Config
                -> Criterion () -- ^ Prepare data prior to executing the first benchmark.
                -> [Benchmark]
                -> IO ()
defaultMainWith' defCfg prep bs = do
  (cfg, args) <- parseArgs defCfg defaultOptions =<< getArgs
  withConfig cfg $
   if cfgPrintExit cfg == List
    then do
      _ <- note "Benchmarks:\n"
      mapM_ (note "  %s\n") (sort $ concatMap benchNames bs)
    else do
      case getLast $ cfgSummaryFile cfg of
        Just fn -> liftIO $ writeFile fn "Name,Mean,MeanLB,MeanUB,Stddev,StddevLB,StddevUB\n"
        Nothing -> return ()
      env <- measureEnvironment
      let shouldRun b = null args || any (`isPrefixOf` b) args
      prep
      runAndAnalyse' shouldRun env $ BenchGroup "" bs

runAndAnalyse' :: (String -> Bool) -- ^ A predicate that chooses
                                  -- whether to run a benchmark by its
                                  -- name.
              -> Environment
              -> Benchmark
              -> Criterion ()
runAndAnalyse' p env = plotAll <=< go ""
  where go pfx (Benchmark desc b)
            | p desc'   = do _ <- note "\nbenchmarking %s\n" desc'
                             summary (show desc' ++ ",") -- String will be quoted
                             (x,an,out) <- runAndAnalyseOne' env desc' b
                             return [(desc',x,an,out)]
            | otherwise = return []
            where desc' = prefix pfx desc
        go pfx (BenchGroup desc bs) =
            concat `fmap` mapM (go (prefix pfx desc)) bs
        prefix ""  desc = desc
        prefix pfx desc = pfx ++ '/' : desc

runAndAnalyseOne' :: Benchmarkable b => Environment -> String -> b
                 -> Criterion (Sample,SampleAnalysis,Outliers)
runAndAnalyseOne' env _desc b = do
  trueTimes <- runBenchmark env b
  let bound = last $ take (V.length trueTimes `div` 10) $ sortBy (flip compare) $ V.toList trueTimes
  let times = V.filter (<bound) trueTimes
  ci <- getConfigItem $ fromLJ cfgConfInterval
  numResamples <- getConfigItem $ fromLJ cfgResamples
  _ <- prolix "analysing with %d resamples\n" numResamples
  an@SampleAnalysis{..} <- liftIO $ analyseSample ci times numResamples
  let OutlierVariance{..} = anOutlierVar
  let wibble = case ovEffect of
                 Unaffected -> "unaffected" :: String
                 Slight -> "slightly inflated"
                 Moderate -> "moderately inflated"
                 Severe -> "severely inflated"
  bs "mean" anMean
  summary ","
  bs "std dev" anStdDev
  summary "\n"
  vrb <- getConfigItem $ fromLJ cfgVerbosity
  let out = classifyOutliers times
  when (vrb == Verbose || (ovEffect > Unaffected && vrb > Quiet)) $ do
    noteOutliers out
    _ <- note "variance introduced by outliers: %.3f%%\n" (ovFraction * 100)
    _ <- note "variance is %s by outliers\n" wibble
    return ()
  return (times,an,out)
  where bs :: String -> Estimate -> Criterion ()
        bs d e = do _ <- note "%s: %s, lb %s, ub %s, ci %.3f\n" d
                      (secs $ estPoint e)
                      (secs $ estLowerBound e) (secs $ estUpperBound e)
                      (estConfidenceLevel e)
                    summary $ printf "%g,%g,%g" 
                      (estPoint e)
                      (estLowerBound e) (estUpperBound e)

plotAll :: [(String, Sample, SampleAnalysis, Outliers)] -> Criterion ()
plotAll descTimes = do
  report (zipWith (\n (d,t,a,o) -> Report n d t a o) [0..] descTimes)
