module Paths_happy (
    version,
    getBinDir, getLibDir, getDataDir, getLibexecDir,
    getDataFileName
  ) where

import qualified Control.Exception as Exception
import Data.Version (Version(..))
import System.Environment (getEnv)
catchIO :: IO a -> (Exception.IOException -> IO a) -> IO a
catchIO = Exception.catch


version :: Version
version = Version {versionBranch = [1,18,9], versionTags = []}
bindir, libdir, datadir, libexecdir :: FilePath

bindir     = "/home/adamsmd/.cabal/bin"
libdir     = "/home/adamsmd/.cabal/lib/happy-1.18.9/ghc-7.4.1"
datadir    = "/home/adamsmd/.cabal/share/happy-1.18.9"
libexecdir = "/home/adamsmd/.cabal/libexec"

getBinDir, getLibDir, getDataDir, getLibexecDir :: IO FilePath
getBinDir = catchIO (getEnv "happy_bindir") (\_ -> return bindir)
getLibDir = catchIO (getEnv "happy_libdir") (\_ -> return libdir)
getDataDir = catchIO (getEnv "happy_datadir") (\_ -> return datadir)
getLibexecDir = catchIO (getEnv "happy_libexecdir") (\_ -> return libexecdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
