{-# OPTIONS  #-}


-- parser (data) produced by Happy (GLR) Version 1.18.6

module ExprData where

-- only list imports here
import Char
import Tree


{-# LINE 1 "templates/GLR_Base.hs" #-}
{-# LINE 1 "templates/GLR_Base.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 1 "templates/GLR_Base.hs" #-}
{- GLR_Base.lhs
   Id: GLR_Base.lhs,v 1.4 2004/12/04 15:01:37 paulcc Exp 
-}

-- Basic defs required for compiling the data portion of the parser

-- We're creating Int-indexed graphs

type ForestId  = (Int,Int,GSymbol)


-- Actions for the GLR machine

data GLRAction = Shift Int [Reduction]
               | Reduce [Reduction]
               | Accept
               | Error

---
-- A Reduction (s,n,f) removes the top n node-ids, creates a new branch from these
-- and labels the branch with the given symbol s. Additionally, the branch may
-- hold some semantic value.

type Reduction = (GSymbol,Int, [ForestId] -> Branch)


---
-- A Branch holds the semantic result plus node ids of children

data Branch
 = Branch {b_sem :: GSem, b_nodes :: [ForestId]}
   deriving Show

instance Eq Branch where
	b1 == b2 = b_nodes b1 == b_nodes b2



-------------------------------------------------------------------------------
-- Utilities for decoding

---
-- Tree decode unpacks the forest into a list of results
--  - this is ok for small examples, but inefficient for very large examples
--  - the data file contains further instances
--  - see documentation for further information
--  - "Decode_Result" is a synonym used to insert the monad type constr (or not)

class TreeDecode a where
	decode_b :: (ForestId -> [Branch]) -> Branch -> [Decode_Result a]

decode :: TreeDecode a => (ForestId -> [Branch]) -> ForestId -> [Decode_Result a]
decode f i@(_,_,HappyTok t)
  = decode_b f (Branch (SemTok t) [])
decode f i
  = [ d | b <- f i, d <- decode_b f b ]

---- generated by Happy, since it means expansion of synonym (not ok in H-98)
--instance TreeDecode UserDefTok where
--	decode_b f (Branch (SemTok t) []) = [happy_return t]

---
-- this is used to multiply the ambiguous possibilities from children

--cross_fn :: [a -> b] -> [a] -> [b]
--actual type will depend on monad in use.
--happy_ap defined by parser generator
cross_fn fs as = [ f `happy_ap` a | f <- fs, a <- as]

---
-- Label decoding unpacks from the Semantic wrapper type
--  - this allows arbitrary values (within the limits of the compiler settings)
--    to be recovered from nodes in the tree.
--  - again, more instances are written in the data file
--  - see documentation for further information

class LabelDecode a where
	unpack :: GSem -> a

---- generated by Happy, since it means expansion of synonym (not ok in H-98)
--instance LabelDecode UserDefTok where
--	unpack (SemTok t) = t




{-# LINE 102 "ExprData.hs"#-}

data Token
	= TokenEOF
	| Sym Char
	| AnInt {getInt :: Int}
  deriving (Show,Eq, Ord)


lexer :: String -> [Token]
lexer [] = []
lexer (' ':cs) = lexer cs

lexer (c:cs) | c `elem` "+*-()" 
 = Sym c : lexer cs

lexer (c:cs) | isDigit c 
 = let (yes,no) = span isDigit cs in AnInt (read $ c:yes) : lexer no

{-# LINE 121 "ExprData.hs"#-}

data GSymbol = HappyEOF | HappyTok {-!Int-} (Token) | G_E 
   deriving (Show,Eq,Ord)

data GSem
 = NoSem
 | SemTok (Token) | Sem_0 (Tree ForestId Int) 
 | Sem_1 (Tree ForestId Int) 
 | Sem_2 (Tree ForestId Int) 
   deriving (Show)


semfn_0_0 ns@(happy_var_1:happy_var_2:happy_var_3:happy_rest) =  Branch (Sem_0 (Plus  happy_var_1 happy_var_3)) ns
semfn_0_1 ns@(happy_var_1:happy_var_2:happy_var_3:happy_rest) =  Branch (Sem_0 (Times happy_var_1 happy_var_3)) ns
semfn_0_2 ns@(happy_var_1:happy_var_2:happy_var_3:happy_rest) =  Branch (Sem_0 (Minus happy_var_1 happy_var_3)) ns
semfn_1_0 ns@(happy_var_1:happy_var_2:happy_rest) =  Branch (Sem_1 (Pars  happy_var_2)) ns
semfn_2_0 ns@((_,_,HappyTok ((AnInt happy_var_1))):happy_rest) =  Branch (Sem_2 (Const happy_var_1)) ns


type Decode_Result a = a
happy_ap = ($)
happy_return = id
instance LabelDecode (Tree ForestId Int) where 
	unpack (Sem_0 s) = s
	unpack (Sem_1 s) = s
	unpack (Sem_2 s) = s


type UserDefTok = Token
instance TreeDecode (Token) where
	decode_b f (Branch (SemTok t) []) = [happy_return t]
instance LabelDecode (Token) where
	unpack (SemTok t) = t


action 0 ( HappyTok (Sym '(') ) = Shift 3 []
action 0 ( HappyTok (AnInt _) ) = Shift 4 []
action 1 ( HappyTok (Sym '(') ) = Shift 3 []
action 1 ( HappyTok (AnInt _) ) = Shift 4 []
action 2 ( HappyTok (Sym '*') ) = Shift 6 []
action 2 ( HappyTok (Sym '+') ) = Shift 7 []
action 2 ( HappyTok (Sym '-') ) = Shift 8 []
action 3 ( HappyTok (Sym '(') ) = Shift 3 []
action 3 ( HappyTok (AnInt _) ) = Shift 4 []
action 4 ( HappyTok (Sym '*') ) = Reduce [red_5]
action 4 ( HappyTok (Sym '+') ) = Reduce [red_5]
action 4 ( HappyTok (Sym '-') ) = Reduce [red_5]
action 4 ( HappyTok (Sym ')') ) = Reduce [red_5]
action 4 ( HappyEOF ) = Reduce [red_5]
action 5 ( HappyTok (Sym '*') ) = Shift 6 []
action 5 ( HappyTok (Sym '+') ) = Shift 7 []
action 5 ( HappyTok (Sym '-') ) = Shift 8 []
action 5 ( HappyEOF ) = Accept
action 6 ( HappyTok (Sym '(') ) = Shift 3 []
action 6 ( HappyTok (AnInt _) ) = Shift 4 []
action 7 ( HappyTok (Sym '(') ) = Shift 3 []
action 7 ( HappyTok (AnInt _) ) = Shift 4 []
action 8 ( HappyTok (Sym '(') ) = Shift 3 []
action 8 ( HappyTok (AnInt _) ) = Shift 4 []
action 9 ( HappyTok (Sym '*') ) = Shift 6 []
action 9 ( HappyTok (Sym '+') ) = Shift 7 []
action 9 ( HappyTok (Sym '-') ) = Shift 8 []
action 9 ( HappyTok (Sym ')') ) = Shift 10 []
action 10 ( HappyTok (Sym '*') ) = Reduce [red_4]
action 10 ( HappyTok (Sym '+') ) = Reduce [red_4]
action 10 ( HappyTok (Sym '-') ) = Reduce [red_4]
action 10 ( HappyTok (Sym ')') ) = Reduce [red_4]
action 10 ( HappyEOF ) = Reduce [red_4]
action 11 ( HappyTok (Sym '*') ) = Shift 6 [red_3]
action 11 ( HappyTok (Sym '+') ) = Shift 7 [red_3]
action 11 ( HappyTok (Sym '-') ) = Shift 8 [red_3]
action 11 ( HappyTok (Sym ')') ) = Reduce [red_3]
action 11 ( HappyEOF ) = Reduce [red_3]
action 12 ( HappyTok (Sym '*') ) = Shift 6 [red_1]
action 12 ( HappyTok (Sym '+') ) = Shift 7 [red_1]
action 12 ( HappyTok (Sym '-') ) = Shift 8 [red_1]
action 12 ( HappyTok (Sym ')') ) = Reduce [red_1]
action 12 ( HappyEOF ) = Reduce [red_1]
action 13 ( HappyTok (Sym '*') ) = Shift 6 [red_2]
action 13 ( HappyTok (Sym '+') ) = Shift 7 [red_2]
action 13 ( HappyTok (Sym '-') ) = Shift 8 [red_2]
action 13 ( HappyTok (Sym ')') ) = Reduce [red_2]
action 13 ( HappyEOF ) = Reduce [red_2]
action _ _ = Error
red_1 = (G_E,3 :: Int,semfn_0_0)
red_2 = (G_E,3 :: Int,semfn_0_1)
red_3 = (G_E,3 :: Int,semfn_0_2)
red_4 = (G_E,3 :: Int,semfn_1_0)
red_5 = (G_E,1 :: Int,semfn_2_0)
goto 0 G_E = 5

goto 1 G_E = 2

goto 3 G_E = 9

goto 6 G_E = 13

goto 7 G_E = 12

goto 8 G_E = 11

goto _ _ = -1
