#!/bin/bash
paste -d, haskell-src.layout/bench.summary \
          haskell-src-1.0.1.5/bench.summary | \
grep "Show Parse" | paste -d, - haskell-src-1.0.1.5/meta-data.txt | \
grep -v "Control/Monad" | \
grep -v "Data/HashTable" | \
grep -v "Data/Maybe" | \
grep -v "Foreign/Marshal/Pool" | \
grep -v "GHC/IO/Buffer" | \
grep -v "GHC/IOArray" | \
grep -v "System/IO" | \
grep -v "Text/Read/Lex" | \
perl -F, -ane '
BEGIN { print "file timeNew errorNew timeOld errorOld ratio ratioError bytes tokens lines nodes\n"; }
die "Mismatch(A) $F[0] and $F[7]"  if $F[0] ne $F[7];
die "Mismatch(B) $F[0] and $F[14]" if $F[0] ne "\"Show Parse/$F[14]\"";
my ($file, $timeNew, $errorNew, $timeOld, $errorOld, $bytes, $tokens, $lines, $nodes) =
   ($F[14],    $F[1],     $F[4],    $F[8],    $F[11], $F[15],  $F[16], $F[17], $F[18]);
my $ratio = $timeNew / $timeOld;
my $x1 = $errorNew/$timeOld;
my $x2 = $errorOld*$timeNew/$timeOld/$timeOld;
my $ratioError = sqrt($x1*$x1+$x2*$x2);
print "$file $timeNew $errorNew $timeOld $errorOld $ratio $ratioError $bytes $tokens $lines $nodes";
' > bench.table
tail --lines=+2 bench.table | \
perl  -ane '
push @xs, $F[5];
push @es, $F[6];
#BEGIN { $prod = 1; $count = 0 }
#$prod *= $F[5];
#$count++;
END {
  my $count = @xs;
  my $prod = 1;
  $prod *= $_ for @xs;
  my $mean = $prod**(1/$count);
  my $sq_error = 0;
  for (0..$#xs) {
  my $err = $es[$_] * $mean / $xs[$_];
printf "err:%.2f %.2f %.2f\n",$err,$es[$_],$xs[$_];
  $sq_error += $err*$err;
  }
  printf "Geo. mean = %.2f +/- %.2f\n", $mean, sqrt($sq_error);
  
}
'
